<?php
// Unclassified NewsBoard
// Copyright 2003-4 by Yves Goergen
// Homepage: http://newsboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// import_ipb11.php
// Database import module
//
// TYPE: Invision Power Board 1.1.2
// The TYPE: description will be used to list this module in the installation

// Disable this file in productive environment!
if (file_exists('lock.conf')) die('The board setup is locked.');

// Debug mode string. Anything with a + in front of it will be enabled
// See forum.php for details.
$DEBUG = '-htmltype +showerrors';

// Prepare debug mode string
$DEBUG = ' ' . strtolower($DEBUG) . ' ';

define('UNB_RUNNING', 1);
define('ERR_REPORT_SET', 1);
define('DISPLAY_ERR_SET', 1);
error_reporting(E_ALL & ~E_NOTICE);

$libpath = 'bb_lib/';

// Import request variables
$step = intval($_REQUEST['step']);
if (!$step) $step = 1;

$INSTALLING = true;
if (!defined('PUBLIC_LIB')) require_once($libpath . 'public.lib.php');
$ME = 'import_ipb112.php';

$step = intval($_REQUEST['step']);
if (!$step) $step = 1;

require_once($libpath . 'common.lib.php');
require($libpath . 'lang/' . $LANG . '_more.php');

@set_time_limit(0);


function group_to_status($group)
{
	// you may need to change this to your group definitions (see groups table)
	//
	switch ($group)
	{
		case 2: return 3;   // admins -> admin
	}
	return 1;
}

function my_strtotime($data)
{
	global $INFO;
	$format = $INFO['clock_long'];   // default: 'M j Y, h:i A' = 'Jul 31 2004, 09:13 PM'

	$mon_length = array(0, 7, 8, 5, 5, 3, 4, 4, 6, 9, 7, 8, 8);

	$pm = false;
	$h12 = false;
	$sec = 0;
	$min = 0;
	$hour = 0;
	$day = 0;
	$month = 0;
	$year = 0;

	for ($fpos = 0, $dpos = 0; $fpos < strlen($format) && $dpos < strlen($data); $fpos++)
	{
		switch ($format{$fpos})
		{
			case 'a':
				$pm = substr($data, $dpos, 2) == 'pm';
				$dpos += 2;
				break;
			case 'A':
				$pm = substr($data, $dpos, 2) == 'PM';
				$dpos += 2;
				break;
			case 'B':
				$dpos += 3;
				break;
			case 'c':
				$dpos += 25;   // TODO: parse this one
				break;
			case 'd':
				$day = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'D':
				$dpos += 3;
				break;
			case 'F':
				$month = array_search(substr($data, $dpos, 3), array('', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'));
				$dpos += $mon_length[$month];
				break;
			case 'g':
				$hour = intval(substr($data, $dpos, 2));
				$h12 = true;
				$dpos += ($hour < 10 ? 1 : 2);
				break;
			case 'G':
				$hour = intval(substr($data, $dpos, 2));
				$dpos += ($hour < 10 ? 1 : 2);
				break;
			case 'h':
				$hour = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'H':
				$hour = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'i':
				$min = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'I':
				$dpos++;
				break;
			case 'j':
				$day = intval(substr($data, $dpos, 2));
				$dpos += ($day < 10 ? 1 : 2);
				break;
			case 'l':
				while ($dpos < strlen($data) && preg_match('/[a-z]/i', $data{$dpos})) $dpos++;
				break;
			case 'L':
				$dpos++;
				break;
			case 'm':
				$month = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'M':
				$month = array_search(substr($data, $dpos, 3), array('', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'));
				$dpos += 3;
				break;
			case 'n':
				$month = intval(substr($data, $dpos, 2));
				$dpos += ($month < 10 ? 1 : 2);
				break;
			case 'O':
				$dpos += 5;
				break;
			case 'r':
				// TODO: Parse RFC 2822 formatted date, ex: Thu, 21 Dec 2000 16:01:07 +0200
				break;
			case 's':
				$sec = intval(substr($data, $dpos, 2));
				$dpos += 2;
				break;
			case 'S':
				$dpos += 2;
				break;
			case 't':
				$dpos += 2;
				break;
			case 'T':
				$dpos += 3;
				break;
			case 'U':
				// TODO: Parse UNIX seconds
				break;
			case 'w':
				$dpos++;
				break;
			case 'W':
				// TODO: Skip 1 or 2 characters? (This is the ISO week number of year)
				break;
			case 'Y':
				$year = intval(substr($data, $dpos, 4));
				$dpos += 4;
				break;
			case 'y':
				$year = intval(substr($data, $dpos, 2));
				if ($year < 80) $year += 1900; else $year += 2000;
				$dpos += 2;
				break;
			case 'z':
				// TODO: Skip 1 to 3 characters? (This is the day of the year)
				break;
			case 'Z':
				// TODO: Skip 1 to 6 characters? (This is the timezone offset in seconds)
				break;

			default:
				$dpos++;
		}
	}

	if ($h12) $hour += ($pm ? 12 : 0);

	return mktime($hour, $min, $sec, $month, $day, $year);
}

//  convert BBCode and pt font sizes to pixel sizes (px)
//
function transl_bbc($txt, $smilies = true)
{
	$txt = str_replace("\r", '', $txt);
	$txt = str_replace("\n", '', $txt);

	$txt = str_replace('<br>', "\n", $txt);
	$txt = str_replace('<b>', '[b]', $txt);
	$txt = str_replace('</b>', '[/b]', $txt);
	$txt = str_replace('<i>', '[i]', $txt);
	$txt = str_replace('</i>', '[/i]', $txt);
	$txt = str_replace('<u>', '[u]', $txt);
	$txt = str_replace('</u>', '[/u]', $txt);

	$txt = str_replace('<ul>', '[list]', $txt);
	$txt = str_replace('</ul>', '[/list]', $txt);
	$txt = str_replace('<li>', '[*]', $txt);

	$txt = preg_replace('/<span style=\'font-family:(.*?);?\'>/i', '[font=$1]', $txt);
	$txt = preg_replace('/<span style=\'font-size:(.*?)pt;?.*?\'>/i', '[size=$1]', $txt);
	$txt = preg_replace('/<span style=\'color:(.*?);?\'>/i', '[color=$1]', $txt);
	$txt = preg_replace('/<\/?span[^>]*>/i', "\x01", $txt);

	// Convert pt to px
	$txt = str_replace('[size=21]', '[size=28]', $txt);
	$txt = str_replace('[size=17]', '[size=23]', $txt);
	$txt = str_replace('[size=16]', '[size=21]', $txt);
	$txt = str_replace('[size=15]', '[size=20]', $txt);
	$txt = str_replace('[size=14]', '[size=19]', $txt);
	$txt = str_replace('[size=13]', '[size=17]', $txt);
	$txt = str_replace('[size=12]', '[size=16]', $txt);
	$txt = str_replace('[size=11]', '[size=15]', $txt);
	$txt = str_replace('[size=10]', '[size=13]', $txt);
	$txt = str_replace('[size=9]', '[size=12]', $txt);
	$txt = str_replace('[size=8]', '[size=11]', $txt);
	$txt = str_replace('[size=7]', '[size=9]', $txt);
	$txt = str_replace('[size=6]', '[size=8]', $txt);
	$txt = str_replace('[size=5]', '[size=7]', $txt);

	// resolve all closing </span>s now
	$stack = array();
	for ($pos = 0; $pos < strlen($txt); $pos++)
	{
		if (substr($txt, $pos, 6) == '[font=') array_push($stack, '[/font]');
		elseif (substr($txt, $pos, 6) == '[size=') array_push($stack, '[/size]');
		elseif (substr($txt, $pos, 7) == '[color=') array_push($stack, '[/color]');
		elseif (substr($txt, $pos, 1) == "\x01") $txt = substr($txt, 0, $pos) . array_pop($stack) . substr($txt, $pos + 1);
	}

	$txt = preg_replace('/<\/?table[^>]*>/i', '', $txt);
	$txt = preg_replace('/<\/?tr[^>]*>/i', '', $txt);
	$txt = preg_replace('/<\/?td[^>]*>/i', '', $txt);

	$txt = preg_replace('/<!--QuoteBegin-->.*?<!--QuoteEBegin-->/i', '[quote]', $txt);
	$txt = preg_replace('/<!--QuoteBegin--(.*?)\+(.*?)-->.*?<!--QuoteEBegin-->/ie', '"[quote=$1:" . my_strtotime("$2") . "]"', $txt);
	$txt = preg_replace('/<!--QuoteEnd-->.*?<!--QuoteEEnd-->/i', '[/quote]', $txt);

	$txt = preg_replace('/<!--c1-->.*?<!--ec1-->/i', '[code]', $txt);
	$txt = preg_replace('/<!--c2-->.*?<!--ec2-->/i', '[/code]', $txt);

	$txt = preg_replace('/<!--emo&(.*?)-->.*<!--endemo-->/i', '$1', $txt);

	$txt = preg_replace('/<a href=\'(.*?)\'(?: target=\'_blank\')?>(.*?)<\/a>/i', '[url=$1]$2[/url]', $txt);
	$txt = preg_replace('/<a href=\'mailto:(.*?)\'>(.*?)<\/a>/i', '[mail=$1]$2[/mail]', $txt);
	$txt = preg_replace('/<img src=\'(.*?)\'[^>]*>/i', '[img]$1[/img]', $txt);

	$txt = str_replace('&gt;', '>', $txt);
	$txt = str_replace('&lt;', '<', $txt);
	$txt = str_replace('&nbsp;', ' ', $txt);
	$txt = str_replace('&quot;', '"', $txt);
	$txt = preg_replace('/&#(\\d+);/e', 'chr(intval("$1"))', $txt);
		// NOTE: Unicode characters would get lost here, but they're not displayed correctly on IPB anyway.
	$txt = str_replace('&amp;', '&', $txt);

	if ($smilies)
	{
		$txt = str_replace('&amp;', '&', $txt);
		$txt = str_replace('&lt;', '<', $txt);
		$txt = str_replace('&gt;', '>', $txt);
		$txt = str_replace('&nbsp;', ' ', $txt);
		$txt = str_replace('&nbsp', ' ', $txt);

		$txt = str_replace(' :D ', ' :-D ', $txt);
		$txt = str_replace(' :oops: ', ' :red: ', $txt);
		$txt = str_replace(' 8) ', ' :cool: ', $txt);
		$txt = str_replace(' :cry: ', ' :\'( ', $txt);
		$txt = str_replace(' :shock: ', ' 8-( ', $txt);
		$txt = str_replace(' :? ', ' 8-( ', $txt);
		$txt = str_replace(' :roll: ', ' :rolleyes: ', $txt);
		$txt = str_replace(' :wink: ', ' ;-) ', $txt);
		$txt = str_replace(' :| ', ' :-/ ', $txt);
		$txt = str_replace(' :P ', ' :-p ', $txt);
	}

	return trim($txt);
}

function transl_lang($lang)
{
	return $lang;
}


if ($step == 1)
{
	BeginHTML($T['installation']);

	echo '<form action="' . $ME . '?step=2' . sid() . '" method="post">';
	echo '<div class="p">Please enter the database name and table prefix of the IPB\'s tables. This database must be located on the primary database server and be accessible with the same username and password.</div>';

	echo '<div class="p"><table>';
	echo '<tr><td>' . $T['db_name'] . ':</td><td><input type="text" class="text" name="dbname" value="' . htmlquote($db->dbname) . '" size="20" /></td></tr>';
	echo '<tr><td>' . $T['db_prefix'] . ':</td><td><input type="text" class="text" name="tblprefix" value="ibf_" size="20" /> (Example: for table names like "ibf_posts", enter "ibf_")</td></tr>';
	echo '<tr><td>Path to board root:</td><td><input type="text" class="text" name="rootpath" value="" size="40" /></td></tr>';
	echo '</table></div>';

	echo '<div class="p"><b>Note:</b> The import process is split up into several steps that are linked with HTML forwards. Each step may take a considerable amount of time. Please don\'t stop the browser, reload the page or click on any of the links as long as the page is still loading or the installation will fail. (You can restart the entire thing again then.)</div>';

	echo '<div class="p"><input type="submit" class="button" value="' . $T['inst_continue'] . '" /></div>';
	echo '</form>';

	EndHTML();
}

// Save form variables from step 1 into session variables to keep them for later steps
if ($step == 2)
{
	$_SESSION['import_dbname'] = $_REQUEST['dbname'];
	$_SESSION['import_tblprefix'] = $_REQUEST['tblprefix'];
	$rootpath = $_REQUEST['rootpath'];   // path to current avatar files (with "/")
	if (substr($rootpath, strlen($rootpath) - 1) != '/') $rootpath .= '/';
	$_SESSION['rootpath'] = $rootpath;
}

// Initialisation for all operative steps
if ($step >= 2)
{
	// Open source database
	$db0 = new IDatabase;
	$db0->server = $db->server;
	$db0->user = $db->user;
	$db0->password = $db->password;
	$db0->dbname = $_SESSION['import_dbname'];
	$db0->tblprefix = $_SESSION['import_tblprefix'];
	$db0->Open() or die('source database open error: ' . t2h($db0->LastError()));

	$av_in_path = trim($_SESSION['import_avpath']);   // path to current avatar files (with "/")
	$rootpath = trim($_SESSION['rootpath']);
	if (preg_match('_^http:|^ftp:_i', $rootpath)) die('<b>UNB error:</b> Root path must not be a remote URL.');

	include($rootpath . 'conf_global.php');
}

if ($step == 2)
{
	// First we have to create all necessary tables.

	// Keep this in sync with the install.php main installer!
	// DO NOT ADD ANY RECORDS HERE (except for some ACL things),
	// because this will lead to duplicate key errors!

	$db->RemoveTable('Forums') or die('remove error: ' . $db->LastError());
	$db->CreateTable('Forums',
					 '`ID` int unsigned not null, ' .             # ID
					 '`Sort` int not null, ' .                    # Order of display
					 '`Parent` int unsigned not null, ' .         # Parent forum (may be category)
					 '`Name` varchar(100) not null, ' .           # Display name
					 '`Flags` int not null, ' .                   # Category/WebLink
					 '`Description` text not null, ' .            # Displayed text
					 '`Link` varchar(255) not null, ' .           # WebLink
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Threads') or die('remove error');
	$db->CreateTable('Threads',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Forum` int unsigned not null, ' .      # What forum if this thread in
					 '`LastPostDate` int not null, ' .        # Date of currently last post (used for display order)
					 '`Subject` varchar(150) not null, ' .    # Displayed subject
					 '`Desc` varchar(150) not null, ' .       # Description
					 '`Date` int not null, ' .                # Date of creation
					 '`User` int unsigned not null, ' .       # User who created this thread
					 '`UserName` varchar(40) not null, ' .    # User name (if guest)
					 '`Views` int unsigned not null, ' .      # Number of visitors here
					 '`Options` int unsigned not null, ' .    # Options (see thread.lib)
					 '`Question` varchar(150) not null, ' .   # Question to be voted about (if poll)
					 '`PollTimeout` int not null, ' .         # Time when this poll should end. 1 if it has been ended manually, 0 = infinite
					 '`LastVoted` int not null, ' .           # Date of last vote (currently unused)
					 'primary key (ID),' .
					 'KEY LastPostDate (LastPostDate)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Posts') or die('remove error');
	$db->CreateTable('Posts',
					 '`ID` int unsigned not null, ' .          # ID
					 '`Thread` int unsigned not null, ' .      # What thread is this post in?
					 '`ReplyTo` int unsigned not null, ' .     # What post is replied by this post to?
					 '`Date` int not null, ' .                 # Date of creation
					 '`EditUser` int unsigned not null, ' .    # User of last modification
					 '`EditDate` int not null, ' .             # Date of last modification
					 '`EditCount` smallint unsigned not null, ' . # Number of modifications
					 '`User` int unsigned not null, ' .        # User who created this post
					 '`UserName` varchar(40) not null, ' .     # User name (if guest)
					 '`Subject` varchar(150) not null, ' .     # Displayed subject, optional
					 '`Msg` text not null, ' .                 # Message body
					 '`Options` int unsigned not null, ' .     # Post options, defined in common library
					 '`AttachFile` varchar(40) not null, ' .   # Attachment, local filename
					 '`AttachFileName` varchar(100) not null, ' . # Attachment, public filename
					 '`AttachDLCount` int unsigned not null, ' . # Attachment, download counter
					 '`IP` varchar(15) not null, ' .           # Creator's IP
					 '`Hostname` varchar(150) not null, ' .    # Creator's Hostname
					 '`SpamRating` int not null, ' .           # SpamRating
					 'primary key (ID), ' .
					 'KEY Thread (Thread), ' .
					 'KEY Date (Date), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$extra = '';
	$db->RemoveTable('Users') or die('remove error');
	$db->CreateTable('Users',
					 '`ID` int unsigned not null, ' .          # ID
					 '`Name` varchar(40) not null, ' .         # Displayed username
					 '`Password` varchar(40) not null, ' .     # MD5-encrypted password
					 '`RegDate` int not null, ' .              # Date of registration
					 '`RegEMail` varchar(100) not null, ' .    # E-Mail at registration time
					 '`DefaultNotify` tinyint unsigned not null, ' . # Default notification
					 '`EMail` varchar(100) not null, ' .       # Current E-Mail
					 '`Jabber` varchar(50) not null, ' .       # Jabber Messenger
					 '`ICQ` varchar(15) not null, ' .          # ICQ
					 '`AIM` varchar(30) not null, ' .          # AOL Instant Messenger
					 '`YIM` varchar(30) not null, ' .          # Yahoo! Instant Messenger
					 '`MSN` varchar(50) not null, ' .          # MSN Messenger
					 '`LastActivity` int not null, ' .         # Date/time of last board activity
					 '`LastForum` int not null, ' .            # Forum the user was last seen in | special action
					 '`LastLogin` int not null, ' .            # Date/time of last login
					 '`LastLogout` int not null, ' .           # Date/time of last 'logout'
					 '`Signature` text not null, ' .           # User's signature
					 '`BirthDay` tinyint unsigned not null, ' . # Day of birthday
					 '`BirthMonth` tinyint unsigned not null, ' . # Month of birthday
					 '`BirthYear` smallint unsigned not null, ' . # Year of birthday
					 '`About` text not null, ' .               # Some text describing the user, displayed in the user's profile
					 '`Title` varchar(40) not null, ' .        # User Title
					 '`Location` varchar(50) not null, ' .     # User's location
					 '`Homepage` varchar(150) not null, ' .    # Homepage
					 '`Gender` char(1) not null, ' .           # Gender. m: male, f: female
					 '`Avatar` varchar(150) not null, ' .      # Avatar file/URL
					 '`AvatarX` smallint not null, ' .         # Avatar image X size
					 '`AvatarY` smallint not null, ' .         # Avatar image Y size
					 '`Photo` varchar(150) not null, ' .       # Photo file/URL
					 $extra .                                  # any extra fields generated above
					 '`ActivateKey` varchar(50) not null, ' .  # Activation Key sent by E-Mail
					 '`RecommendedBy` int unsigned not null, ' . # User was recommended by another user(id)
					 '`Design` tinyint not null default -1, ' . # User's design choose (-1 for forum default)
					 '`ThreadIcons` tinyint not null, ' .      # Show icons/text for Thread actions, 0:icons, 1:text, 2:both
					 '`Flags` int unsigned not null, ' .       # some other flags
					 '`Timezone` tinyint NOT NULL default 99, ' . # timezone in 1/4 hours, relative to UTC. (99 is default)
					 '`TimezoneDS` tinyint NOT NULL default -1, ' . # daylight saving time? (-1 default)
					 '`EditControls` int unsigned NOT NULL, ' .
					 '`ThreadsPerPage` smallint NOT NULL default -1, ' .
					 '`ThreadSort` smallint NOT NULL default -1, ' .
					 '`ThreadTime` smallint NOT NULL default -1, ' .
					 '`Favourites` text NOT NULL, ' .
					 '`Language` varchar(6) NOT NULL, ' .
					 '`DateFormat` varchar(20) NOT NULL, ' .
					 'primary key (ID),' .
					 'KEY LastActivity (LastActivity)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('PollVotes') or die('remove error');
	$db->CreateTable('PollVotes',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Thread` int unsigned not null, ' .     # Thread this poll belongs to
					 '`Sort` tinyint not null, ' .            # Order of display
					 '`Title` varchar(100) not null, ' .      # Displayed voting option
					 '`Votes` int unsigned not null, ' .      # Number of votes for this option
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('PollUsers') or die('remove error');
	$db->CreateTable('PollUsers',
					 '`Thread` int unsigned not null, ' .     # Thread we're talking about
					 '`User` int unsigned not null, ' .       # User that has already voted in above thread
					 '`VoteNum` int unsigned not null, ' .    # User's vote, saved to change this later
					 'primary key (Thread, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Announces') or die('remove error');
	$db->CreateTable('Announces',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Forum` int not null, ' .               # What forum if this announcement belongs to (0 for any)
					 '`Date` int not null, ' .                # Date of creation
					 '`User` int unsigned not null, ' .       # User who created this announcement
					 '`Subject` varchar(150) not null, ' .    # Displayed subject
					 '`Msg` text not null, ' .                # Message body
					 '`Options` int unsigned not null, ' .    # several Flags...
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('AnnounceRead') or die('remove error');
	$db->CreateTable('AnnounceRead',
					 '`Msg` int unsigned not null, ' .        # Announcement we're talking about
					 '`User` int unsigned not null, ' .       # User that already read above announcement
					 'primary key (Msg, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ThreadWatch') or die('remove error');
	$db->CreateTable('ThreadWatch',
					 '`Thread` int unsigned not null, ' .      # Thread we're talking about
					 '`User` int unsigned not null, ' .        # User that is watching above thread
					 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both
					 '`LastRead` int not null, ' .             # Timestamp of last read time
					 '`LastNotify` int not null, ' .           # Timestamp of last new-post notification
					 '`LastViewed` int not null, ' .           # Timestamp of last topic view time
					 'PRIMARY KEY (Thread, User), ' .
					 'KEY Thread (Thread), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ForumWatch') or die('remove error');
	$db->CreateTable('ForumWatch',
					 '`Forum` int unsigned not null, ' .       # Forum we're talking about
					 '`User` int unsigned not null, ' .        # User that is watching above thread
					 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both, 4: Jabber...
					 '`Flags` tinyint unsigned not null, ' .   # More flags. 1: recursive
					 '`LastVisited` int not null, ' .          # Timestamp of last visit time
					 '`LastNotify` int not null, ' .           # Timestamp of last new-thread notification
					 'PRIMARY KEY (Forum, User), ' .
					 'KEY Forum (Forum), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('UserForumFlags') or die('remove error');
	$db->CreateTable('UserForumFlags',
					 '`User` int unsigned not null, ' .      # User that has set the state
					 '`Forum` int unsigned not null, ' .     # Forum (category) we're talking about
					 '`Thread` int unsigned not null, ' .    # Thread ID
					 '`Flags` tinyint unsigned not null, ' .
					 # Flags: 1: Category collapsed, 2: Forum/Thread ignored
					 'primary key (User, Forum, Thread)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Guests') or die('remove error');
	$db->CreateTable('Guests',
					 '`Session` varchar(80) not null, ' .    # Guest user's PHP session ID
					 '`LastActivity` int not null, ' .       # Last update of record
					 '`LastForum` int unsigned not null, ' . # Last forum of guest
					 '`UserName` varchar(40) not null'       # Name
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Stat') or die('remove error');
	$db->CreateTable('Stat',
					 '`Date` int not null, ' .               # Day of record
					 '`NewThreads` int not null, ' .         # New threads created on this day
					 '`NewPosts` int not null, ' .           # New posts send on this day
					 '`OnlineUsers` int not null, ' .        # Number of users online on this day
					 '`OnlineGuests` int not null, ' .       # Number of guests online on this day
					 '`PageHits` int not null, ' .           # Number of (almost total) page hits on this day
					 '`NewUsers` int not null, ' .           # Registrations on this day
					 'primary key (Date)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ACL') or die('remove error');
	$db->CreateTable('ACL',
					 '`ID` int unsigned not null, ' .           # unique ID
					 '`User` int unsigned not null, ' .         # user ID
					 '`Group` int unsigned not null, ' .        # group ID
					 '`Action` smallint unsigned not null, ' .  # action ID
					 '`Thread` int unsigned not null, ' .       # thread ID
					 '`Forum` int unsigned not null, ' .        # forum ID
					 '`Grant` int not null, ' .                 # grant this right? | some other numeric value for it
					 '`Enabled` bool not null, ' .              # use this entry?
					 'primary key (ID), ' .
					 'UNIQUE INDEX (User, `Group`, Action, Thread, Forum)'
		) or die('create error: ' . $db->LastError());

	$db->SetTable('ACL');
	$db->AddRecord(array('ID' => 1,
						 'User' => 0,
						 'Group' => 0,
						 'Action' => 33,   // viewforum
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 2,
						 'User' => 0,
						 'Group' => 1,
						 'Action' => 82,   // user rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 3,
						 'User' => 0,
						 'Group' => 2,
						 'Action' => 83,   // mod rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 4,
						 'User' => 0,
						 'Group' => 3,
						 'Action' => 84,   // admin rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->RemoveTable('GroupMembers') or die('remove error');
	$db->CreateTable('GroupMembers',
					 '`Group` int unsigned not null, ' .   # group ID
					 '`User` int unsigned not null, ' .    # user ID
					 'primary key (`Group`, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('GroupNames') or die('remove error');
	$db->CreateTable('GroupNames',
					 '`ID` int unsigned not null, ' .         # group ID
					 '`Name` varchar(50) not null, ' .        # group name
					 '`ShowInTeam` tinyint(1) not null, ' .   # show in the team list
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());

	$db->SetTable('GroupNames');
	$db->AddRecord(array('ID' => 1,
						 'Name' => $T['inst_grp_users'],
						 'ShowInTeam' => 0
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 2,
						 'Name' => $T['inst_grp_gmods'],
						 'ShowInTeam' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 3,
						 'Name' => $T['inst_grp_admins'],
						 'ShowInTeam' => 1
		)) or die('add error: ' . $db->LastError());

	// ------------------------------------------------------------ FORUMS

	// categroies and forums IDs cannot be the same here!

	// so we append the cat IDs after the forums IDs number space
	$fmax = $db0->FastQuery1st('forums', 'MAX(id)');

	$db->SetTable('Forums');
	$arr = $db0->FastQueryArray('categories');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('ID' => $a['id'] + $fmax + 1,
							 'Sort' => $a['position'],
							 'Parent' => 0,
							 'Name' => transl_bbc($a['name']),
							 'Description' => transl_bbc($a['description']),
							 'Flags' => 1
			)) or die('[forums] add error: ' . $db->LastError());
	}

	$arr = $db0->FastQueryArray('forums');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('ID' => $a['id'],
							 'Sort' => $a['position'],
							 'Parent' => $a['category'] + $fmax + 1,
							 'Name' => transl_bbc($a['name']),
							 'Description' => transl_bbc($a['description']),
							 'Flags' => 0
			)) or die('[forums] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ THREADS

	$db->SetTable('Threads');
	$arr = $db0->FastQueryArray('topics');
	if ($arr) foreach($arr as $a)
	{
		$timeout = 0;
		$question = '';

		// is this a poll?
		$vote = ($a['poll_state'] != '0');
		if ($vote)
		{
			$vrec = $db0->FastQuery('polls', '*', 'tid=' . $a['tid']);
			$question = $vrec['poll_question'];
		}

		$options = 0;
		if ($a['state'] == 'closed') $options |= 1;   // closed
		if ($a['moved_to']) $options |= 8;   // moved
		if ($a['pinned']) $options |= 2;   // important
		if ($vote) $options |= 4;   // poll

		if ($a['moved_to'])   // moved
		{
			$question = $a['moved_to'];
			$timeout = time() + 14 * 24 * 3600;   // show "moved" link for 14 days
		}

		$db->AddRecord(array('ID' => $a['tid'],
							 'Forum' => $a['forum_id'],
							 'LastPostDate' => 0,  // we do it ourselves later
							 'Subject' => transl_bbc($a['title']),
							 'Desc' => transl_bbc($a['description']),
							 'Date' => $a['start_date'],
							 'User' => max(0, $a['starter_id']),   // must be >= 0
							 'UserName' => $a['starter_name'],
							 'Views' => $a['views'],
							 'Options' => $options,
							 'Question' => $question,
							 'PollTimeout' => $timeout
			)) or die('[threads] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=3' . sid());
}

if ($step == 3)
{
	// ------------------------------------------------------------ POSTS

	$db->SetTable('Posts');
	$arr = $db0->FastQueryArray('posts');
	if ($arr) foreach($arr as $a)
	{
		$afile = '';
		if ($a['attach_id'] != '')
		{
			$ext = substr($a['attach_file'], strrpos($a['attach_file'], '.'));
			$afile = $upload_path . 'post_' . $a['pid'] . $ext;
			if (!@copy($rootpath . $INFO['upload_dir'] . $a['attach_id'], $afile))
			{
				echo '<b>Warning:</b> Couldn\'t copy post attachment file ' . $a['attach_id'] . '<br />';
			}
		}

		$db->AddRecord(array('ID' => $a['pid'],
							 'Thread' => $a['topic_id'],
							 'ReplyTo' => 0,
							 'Date' => $a['post_date'],
							 'EditUser' => 0,
							 'EditDate' => $a['edit_time'],
							 'EditCount' => ($a['edit_time'] > 0 ? 1 : 0),
							 'User' => $a['author_id'],
							 'UserName' => $a['author_name'],
							 'Subject' => transl_bbc($text['post_title']),
							 'Msg' => transl_bbc($a['post'], $a['use_emo']),
							 'Options' => ($a['use_emo'] ? 0 : 1),
							 'IP' => $a['ip_address'],
							 'AttachDLCount' => $a['attach_hits'],
							 'AttachFile' => $afile,
							 'AttachFileName' => $a['attach_file'],
							 'Hostname' => '',
							 'SpamRating' => 0
			)) or die('[posts] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=4' . sid());
}

if ($step == 4)
{
	// ------------------------------------------------------------ USERS

	include($rootpath . 'conf_global.php');

	$arr = $db0->FastQueryArray('members');
	if ($arr) foreach($arr as $a)
	{
		if ($a['id'] <= 0) continue;

		$avatar = '';
		if (!strncmp($a['avatar'], 'http:', 5))
		{
			$avatar = $a['avatar'];
		}
		else if (!strncmp($a['avatar'], 'upload:', 7))
		{
			$avatar = substr($a['avatar'], 7);
			if (!@copy($rootpath . $INFO['upload_dir'] . $avatar, $avatar_path . $avatar))
			{
				echo '<b>Warning:</b> Couldn\'t copy user avatar file ' . $avatar . '<br />';
			}
		}
		else
		{
			$ext = substr($a['avatar'], strrpos($a['avatar'], '.'));
			$avatar = 'avatar_' . $a['id'] . $ext;
			if (!@copy($rootpath . $INFO['html_dir'] . 'avatars/' . $a['avatar'], $avatar_path . $avatar))
			{
				echo '<b>Warning:</b> Couldn\'t copy user avatar file ' . $a['avatar'] . '<br />';
			}
		}

		$db->AddRecord(array('ID' => $a['id'],
							 'Name' => $a['name'],
							 'Password' => $a['password'],
							 'RegDate' => $a['joined'],
							 'RegEMail' => '[' . $a['ip_address'] . ']',
							 'DefaultNotify' => ($a['auto_track'] ? 1 : 0),
							 'EMail' => $a['email'],
							 'ICQ' => $a['icq_number'],
							 'AIM' => $a['aim_name'],
							 'YIM' => $a['yahoo'],
							 'MSN' => $a['msnname'],
							 'LastActivity' => $a['last_activity'],
							 'LastForum' => 0,
							 'Signature' => transl_bbc($a['signature']),
							 'BirthDay' => $a['bday_day'],
							 'BirthMonth' => $a['bday_month'],
							 'BirthYear' => $a['bday_year'],
							 'About' => $a['interests'],
							 'Location' => $a['location'],
							 'Homepage' => $a['website'],
							 'Avatar' => $avatar,
							 'ActivateKey' => $a['validate_key'],
							 'Flags' => 2 + 4 + 32 + ($a['email_full'] ? 64 : 0) + 128 + (rc('new_layout') ? 256 : 0) + ($a['view_avs'] ? 0 : 1024) + ($a['view_sigs'] ? 0 : 2048),
							 'Language' => transl_lang($a['language']),
							 'Timezone' => ($a['time_offset'] == 0 ? 99 : $a['time_offset'] * 4),
							 'TimezoneDS' => $a['dst_in_use']
			), 'Users') or die('[users] add error: ' . $db->LastError());

		$db->AddRecord(array('User' => $a['id'],
							 'Group' => 1
			), 'GroupMembers') or die('[group members] add error: ' . $db->LastError());
		if ($a['mgroup'] == $INFO['admin_group'])
		{
			$db->AddRecord(array('User' => $a['id'],
								 'Group' => 3
				), 'GroupMembers') or die('[group members] add error: ' . $db->LastError());
		}
	}

	// ------------------------------------------------------------ POLL VOTES

	$i = 1;
	$db->SetTable('PollVotes');
	$arr = $db0->FastQueryArray('polls');
	if ($arr) foreach($arr as $a)
	{
		// Each IPB poll contains all vote options, they must be stored in different records now
		$choices = unserialize($a['choices']);

		foreach ($choices as $choice)
		{
			$db->AddRecord(array('ID' => $i++,
								 'Thread' => $a['tid'],
								 'Sort' => $choice[0],
								 'Title' => transl_bbc($choice[1]),
								 'Votes' => $choice[2]
				)) or die('[poll votes] add error: ' . $db->LastError());
		}
	}

	// ------------------------------------------------------------ POLL USERS

	$db->SetTable('PollUsers');
	$arr = $db0->FastQueryArray('voters');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('Thread' => $a['tid'],
							 'User' => intval($a['member_id']),
							 'VoteNum' => 0
			)) or die('[poll users] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ THREADWATCH

	$db->SetTable('ThreadWatch');
	$arr = $db0->FastQueryArray('tracker');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('Thread' => $a['topic_id'],
							 'User' => intval($a['member_id']),
							 'Mode' => 1   // always notify via e-mail
			)) or die('[thread watch] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ FORUMWATCH

	$db->SetTable('ForumWatch');
	$arr = $db0->FastQueryArray('forum_tracker');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('Forum' => $a['forum_id'],
							 'User' => intval($a['member_id']),
							 'Mode' => 1   // always notify via e-mail
			)) or die('[thread watch] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=5' . sid());
}

if ($step == 5)
{
	// ------------------------------------------------------------ CONFIG

	$CONFFILE['forum_title'] = $INFO['boardname'];

	if (!rebuild_conffile() && !rc('nowrite')) die($T['err_write_conffile']);

	ForwardHTML($ME . '?step=6' . sid());
}

if ($step == 6)
{
	BeginHTML($T['installation']);
	echo '<div class="p">';
	echo 'Conversion finished. ' . $T['inst_check_db_integrity'] . '<br />';

	// Set correct LastPostDate for all threads
	$thread = new IThread;
	$arr = $db->FastQueryArray('Threads');
	if ($arr) foreach($arr as $a)
	{
		$record = GetLastPost(intval($a['ID']));
		$thread->SetLastPostDate($record['Date'], $a['ID']);
	}

	// Add thread-has-attachment flags
	$thread = new IThread;
	$thread2 = new IThread;
	$post = new IPost;
	if ($thread->Find()) do
	{
		$found = $post->Find('Thread=' . $thread->GetID() . " AND AttachFile<>''", '', 1);

		$opt = $thread->GetOptions();
		$opt = ($opt & ~16) | (($found ? 1 : 0) * 16);
		$thread2->SetOptions($opt, $thread->GetID());   // no error detection here
	}
	while ($thread->FindNext());

	// Store correct avatar image dimensions
	$user = new IUser;
	if ($user->GetList()) do
	{
		if ($user->GetAvatar() != '')
		{
			$is = @getimagesize((strpos($user->GetAvatar(), ':') ? '' : $avatar_path) . $user->GetAvatar());
			if (is_array($is))
			{
				$newx = $is[0];
				$newy = $is[1];
				if (!$db->ChangeRecord(array('AvatarX' => $newx, 'AvatarY' => $newy), 'ID=' . $user->GetID(), 'Users'))
				{
					echo 'Warning: Database error: ' . t2h($db->LastError()) . '<br />';
				}
			}
		}
	}
	while ($user->GetNext());

	echo '<b>' . $T['inst_done'] . '</b></div>';

	echo '<div class="p">Import process finished. Not all information from the board software may have been copied, please check the new board configuration and all access rights (user groups, forum access rights, ACL). It\'s recommended to fully check the database integrity again from the Administrator\'s Control Panel and correct possible discrepancies.</div>';

	echo '<div class="p">' . $T['inst_upgrade_note'] . '</div>';

	echo '<div class="p">You may need to convert all data stored in the database to UTF-8 unicode character encoding, if this is enabled for your UNB installation. You can find a basic conversion tool in the docs/tools/ directory of the release archive. Copy it to the installation PHP files and call it via your browser. If you already copied the file, this link may work: <a href="_convert_utf8.php' . sid() . '">Convert to UTF-8</a> <i>(First remove the lock.conf file again!)</i></div>';

	if (!rc('nowrite')) touch('lock.conf');
	echo '<div class="p">' . $T['inst_lock'] . '</div>';

	echo '<div class="p"><a href="' . $MODULE['main'] . sid(2) . '">' . $T['inst_go_overview'] . '</a></div>';
	EndHTML();
}

?>
